#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>

#include <pthread.h>

#include "irs_ts_ws.h"

int irs_ts_ws_data;

void *irs_ts_ws_read(int *irs_no)
{

	int cmd,i;
        int fd4;
	int mark;

	char *irs_data;
	char irs_dat[13];

	cmd=*irs_no;
	printf("uss_no =%d\n",cmd);


        while(1) {
        if ((fd4 = open("/dev/irs_ts_ws", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/irs_ts\n");
                exit(1);
        }
		mark=0;
		irs_data=irs_dat;
	        read(fd4,irs_data,13);
        	//for(i=4;i<5;i++){
        	for(i=0;i<4;i++){
           		printf(" TS[%d] = %c\n",i+1,*irs_data);
			irs_dat[i]=*irs_data;
			if(*irs_data=='1' && i >=2) mark=1;
           		irs_data++;
       		}
        	for(i=4;i<8;i++){
           		printf(" IRS[%d] = %c\n",i-3,*irs_data);
			irs_dat[i]=*irs_data;
			if(*irs_data=='1' && i >=2) mark=1;
           		irs_data++;
       		}
        	for(i=8;i<12;i++){
           		printf(" WS[%d] = %c\n",i-7,*irs_data);
			irs_dat[i]=*irs_data;
			if(*irs_data=='1' && i >=2) mark=1;
           		irs_data++;
       		}

                printf("\n");
                printf("mark=%d\n",mark);
		//if(mark==1) break;

	close(fd4);
		 usleep(1000000);
        }

        pthread_exit(0);
}

int main()
{

        pthread_t irs_ts_ws_task;
        pthread_attr_t attr_irs_ts_ws;
	struct sched_param sched_param;

	int irs_no;
	int ret;

        pthread_attr_init (&attr_irs_ts_ws);
        sched_param.sched_priority = 21;
	pthread_attr_setschedpolicy(&attr_irs_ts_ws, SCHED_RR);
        pthread_attr_setschedparam(&attr_irs_ts_ws, &sched_param);

	irs_no=3;

       	ret=pthread_create( &irs_ts_ws_task, &attr_irs_ts_ws, (void*)irs_ts_ws_read, &irs_no);
	ret=pthread_join(irs_ts_ws_task,NULL);

	//printf("irs_dat[2] %d\n",irs_data);

	return 0;
}
