#include "mirs_head.h"
#include "define.h"

#define ANG_1 3 
#define USS_MAX3 1200 

int near_search(int target,int select_number){
	FILE *fp,*fp2;
	int j,rank2,sub_dis[6],sub_ang[6],x,y,rotate_ang,rotate_time;
	double sub2,dis2,ang2,rag,sx,sy;
	/*for exception get*/
	int angle=0;
	int dis_moved=0,tmp_left=0,tmp_right=0,error=0;
	
/*use local*/
	int post_ang2[25],post_dis2[25],post_number2;

/*use search*/
	struct dat{
		int ang[100];
		int dis[100];
		int flg[100];
	};
	struct dat dat;		//debug
	int i,j1,j2,j3,cnt=0,bef_cnt,aft_cnt,index,ang,dis;
//	int data;
	float lm,rm,lv,rv;
	int br;
	fp = fopen("txt/approach2_search.txt","w");

	rotate_ang = 0;
	rotate_time = 0;

	switch (select_number){
		case 1:					
			rotate_ang=90;
			rotate_time=4000;
			break;

		case 2:
			rotate_ang=190;
			rotate_time=12000;
			break;

		case 3:
			rotate_ang=270;
			rotate_time=11000;
			break;
			
		case 4:
			rotate_ang=373;
			rotate_time=15000;
			break;		
			
		default:
			printf("input error\n");
			printf("not start cmc\n");
			break;
	}
	fprintf(fp,"rotate_ang=%d rotate_time=%d\n",rotate_ang,rotate_time);
	
/*post_search*/
SEARCH:

	for(i=0;i<100;i++){
		dat.ang[i]=0;
		dat.dis[i]=0;
		dat.flg[i]=0;
	}
	for(i=0;i<6;i++){
		sub_dis[i]=0;
		sub_ang[i]=0;
	}
	for(i=0;i<25;i++){
		post_ang2[i]=0;
		post_dis2[i]=0;
	}


	pthread_create(&uss_task,&attr_uss,&uss_read,(void *)1);
	uss_msg.command=2;
	uss_msg.number=3;
	uss_msg.period=100;
	write(ctl,&uss_msg,sizeof(uss_msg));
	usleep(200000);
	
	angle=0;dis_moved=0;tmp_left=0;tmp_right=0;error=0;
	cnt=0;
	pwm_enco_start(10);
	pwm_lqr_rotate(rotate_ang,rotate_time);
	while(m[2]>360){m[2]-=360;}
	while(m[2]<0){m[2]+=360;}
	
	usleep(4000);
	count.br=0;
	printf("test\n");
	while(1){
		printf("test1\n");
		encoder_data(&lm,&rm,&lv,&rv,&br);
		printf("\ttest1-1\n");
		
		if(count.left_sum==tmp_left && count.right_sum==tmp_right){
			error++;
		}else{
			tmp_left=count.left_sum;
			tmp_right=count.right_sum;
			error=0;
		}

		ang=(((lm+rm)/2)*360)/(2*PI*dist_ct);
		if(ang<190 && (cnt==0 || ang-dat.ang[cnt-1]>PERI_ANG)){
			printf("teat1-2\n");
			dat.ang[cnt]=ang;
			dat.dis[cnt]=uss_data;
			cnt++;
			fprintf(fp,"cnt=%d ang=%d uss_data=%d\n",cnt,ang,uss_data);
		}

        if(error>50 || count.br==1){
			fp2=fopen("txt/near_search_error.txt","w");
			fprintf(fp2,"near_search_error");
			pthread_cancel(uss_task);
			pwm_both_data(0,0);
			usleep(40000);
			ang=(((lm+rm)/2)*360)/(2*PI*dist_ct);
			m[2] += ang;
			fclose(fp2);
			break;
		}
		
	}
	printf("test2\n");
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();

	/*error case*/

	if(error>50){
			m[2] += lqr_rotate(-30,500);
			lqr_straight(-300,1000);
			goto SEARCH;
	}

	
//	m[2]+=180;

/*remove large data(post_search)*/
	for(i=0;i<30;i++){
		if(dat.dis[i]>USS_MAX3){
			dat.flg[i]=1;
		}
	}


/*select most smole data*/

JUDGE:

	//judgement and determin post

	//first. find minimum distance
	printf("\nfind minimum distance\n");
	index=-1;
	for(i=0;i<cnt;i++){
		if(dat.flg[i]==0){index=i;}
	}
	if(index==-1){
		goto END;
	}
	for(i=1;i<cnt;i++){
		if(dat.dis[index]>dat.dis[i] && dat.flg[i]==0){
			index=i;
		}
	}
	printf("minimun index=%d\n",index);
//	scanf("%d",&data);									//DEBUG

	//second. check before and after data

	//check AFTER data
	printf("\ncheck AFTER data\n");
	aft_cnt=0;
	for(i=index;i<index+6;i++){
		if(i>=cnt){j1=i-cnt;}else{j1=i;}
		if((i+1)>=cnt){j2=i+1-cnt;}else{j2=i+1;}
		if((i+2)>=cnt){j3=i+2-cnt;}else{j3=i+2;}
		dis=dat.dis[j2]+(dat.dis[j2]-dat.dis[j1]);	//rironti
		printf("judge dat.dis[%d]=%d - dis[%d]=%d -> dis[%d]=%d( %d )\n",j1,dat.dis[j1],j2,dat.dis[j2],j3,dat.dis[j3],dat.flg[j3]);
		if((dis+PLS_HOSEI>dat.dis[j3] && dis-MNS_HOSEI<dat.dis[j3]) && dat.flg[j3]==0){
			printf("OK\n");
			if(aft_cnt==0){aft_cnt+=2;}else{aft_cnt++;}
		}else{
			break;
		}
	}
	fprintf(fp,"after_count = %d\n",aft_cnt);
//	scanf("%d",&data);									//DEBUG

	//check BEFORE data
	fprintf(fp,"\ncheck BEFORE data\n");
	bef_cnt=0;
	for(i=index;i>index-6;i--){
		if(i<0){j1=i+cnt;}else{j1=i;}
		if((i-1)<0){j2=i-1+cnt;}else{j2=i-1;}
		if((i-2)<0){j3=i-2+cnt;}else{j3=i-2;}
		dis=dat.dis[j2]+(dat.dis[j2]-dat.dis[j1]);	//rironti
		fprintf(fp,"judge dat.dis[%d]=%d - dis[%d]=%d -> dis[%d]=%d( %d )\n",j1,dat.dis[j1],j2,dat.dis[j2],j3,dat.dis[j3],dat.flg[j3]);
		if((dis+PLS_HOSEI>dat.dis[j3] && dis-MNS_HOSEI<dat.dis[j3]) && dat.flg[j3]==0){
			fprintf(fp,"OK\n");
			if(bef_cnt==0){bef_cnt+=2;}else{bef_cnt++;}
		}else{
			break;
		}
	}
	fprintf(fp,"before_count = %d\n",bef_cnt);
//	scanf("%d",&data);									//DEBUG

	//third. judge total point
	fprintf(fp,"\njudge total point\n");
	fprintf(fp,"aft_cnt=%d, bef_cnt=%d\n",aft_cnt,bef_cnt);
	if((aft_cnt+bef_cnt)>=CLR_POINT){
		fprintf(fp,"there is POST !!!!\n");
		dat.flg[index]=2;	//<- post
		//remove checked data
		for(i=index+1;i<=index+aft_cnt;i++){
			if(i>=cnt){j1=i-cnt;}else{j1=i;}
			dat.flg[j1]=1; //no data
			fprintf(fp,"remove data: dat.dis[%d]=%d\n",j1,dat.dis[j1]);
		}
		for(i=index-1;i>=index-bef_cnt;i--){
			if(i<0){j1=i+cnt;}else{j1=i;}
			dat.flg[j1]=1; //no data
			fprintf(fp,"remove data: dat.dis[%d]=%d\n",j1,dat.dis[j1]);
		}
	}else{
		fprintf(fp,"there is NOT POST...\n");
		dat.flg[index]=1;
	}
//	scanf("%d",&data);									//DEBUG

	goto JUDGE;

END:
	fprintf(fp,"\nselect post data\n");
	j1=0;
	for(i=0;i<cnt;i++){
		fprintf(fp,"check data: dat.dis[%d]=%d, flg[%d]=%d\n",i,dat.dis[i],i,dat.flg[i]);
		if(dat.flg[i]==2){
			ang=dat.ang[i]+POST_ANG_DIFF;
			while(ang>=360){ang-=360;}
			dis=dat.dis[i]+USS_CORRECT+MCENTER_USS3_DIS+post_diameter/2;
			fprintf(fp,"dat.ang[%d]=%d, dis[%d]=%d\n",i,dat.ang[i],i,dat.dis[i]);
			post_ang2[j1]=dat.ang[i]+ANG_1;
			post_dis2[j1]=dat.dis[i];
			j1++;
		}
	}
	post_number2=j1;

/*joudge post is found*/
	if(post_dis2[0]==0){
		m[2]+=lqr_rotate(190,3000);
		while(m[2]>360){m[2]-=360;}
		lqr_straight(100,500);
		goto SEARCH;
	}	
/*set dis snd ang*/
	for(i=1;i<=5;i++){
		sub_ang[i]=post_ang2[i-1];
		sub_dis[i]=post_dis2[i-1];
		fprintf(fp,"%d ang=%d dis=%d\n",i,sub_ang[i]+360,sub_dis[i]);
	}
/*chose smale post*/
	rank2=1;
	for(i=1;i<=4;i++){
		for(j=1+i;j<=5;j++){
			if(sub_dis[i]>sub_dis[j] && sub_ang[j]<185){
				if(sub_dis[j]>0){	
					rank2=j;
				}
			}
		}
	}
	dis2=(double)sub_dis[rank2];
	ang2=(double)sub_ang[rank2]-270+(double)m[2];
	while(ang2>360){ang2-=360;}
	while(ang2<0){ang2+=360;}
	ang=sub_ang[rank2];
	printf("\nang=%d ang2=%f dis2=%f",ang,ang2,dis2);
	fprintf(fp,"\nang=%d ang2=%f dis2=%f",ang,ang2,dis2);
/*dis and ang => xy (use mirs data)*/
	rag=ang2*PI/180;
	sx=dis2*cos(rag)/ONE_B;
	sy=dis2*sin(rag)/ONE_B;
	fprintf(fp,"sx=%f sy=%f\n",sx,sy);

	x=half_adjust(sx);
	y=half_adjust(sy);

	fprintf(fp,"x=%d y=%d\n",x,y);
	m[1]=px[target]-x;
	m[0]=py[target]-y;
	while(m[2]>360){m[2]-=360;}
	fprintf(fp,"m[1]=%d m[0]=%d m[2]=%d\n",m[1],m[0],m[2]);

/*lqr control*/

	fprintf(fp,"lqr_rotate\nang=%d time=%d\n",ang-270,rotate_time);
	printf("lqr_rotate\nang = %d time = %d\n",ang-270,rotate_time);
//	rotate_ang=(int)((360+ang)*1.036+0.5);
	ang = Wangle(ang)-270;
	m[2]+=ang;
//	ang = (int)(((double)Wangle(ang)-270)*MIRS);
//	ang = Mangle(ang);
	ang2=(double)ang*MIRS;
	ang=(int)(ang2+0.5);
	lqr_rotate(ang,ang*19);
	fprintf(fp,"rotate ang=%d\n",ang);
	while(m[2]>360){m[2]-=360;}
	while(m[2]<0){m[2]+=360;}
	fprintf(fp,"m[2]=%d\n",m[2]);
	
	fclose(fp);
	return sub_dis[rank2];
}
